#pragma once

#include "fault.h"

#include <map>
#include <set>

using ll = long long;

namespace atpg_ls {

class Simulator;

class Circuit {
public:
std::vector<Gate*> PIs;
std::vector<Gate*> POs;
std::vector<Gate*> gates;
std::vector<Gate*> rtopo_gates;
std::vector<Gate*> original_gates;

// std::vector<Gate*> test;

std::unordered_map<std::string, Gate*> name2gate;

void parse_from_file(const char *filename);
void insert_lines_for_stem();
void rebuild_atpg_circuit();
void init_faults();
int cal_circuit_score();

void print();

void init_topo_index();

// atpg info

std::set<Fault> detected_faults;
std::set<Fault> undetected_faults;
std::set<Fault> unknown_faults;
std::set<Fault> faults;

std::map<Fault, TMP_FAULT> mp;

void ls_update();
Gate* ls_pick();
void ls_flip(Gate *gate);
void ls_main();
void ls_init();
void ls_random_sol();
void ls_gen_sol(const Fault &f);

// checker
double check();

// simulator

Simulator *simulator;

};

}