#include "circuit.h"

using namespace atpg_ls;

void Gate::cal_score() {
    score = 0;

    if(value == 1) {
        score -= weight;
    } else {
        score += weight;
    }

    if(!isPI) {
        if(v_sat) {
            score -= unsat_cost;
        } else {
            score += unsat_cost;
        }
    }

    value ^= 1;

    for(Gate* out : fanouts) {
        if(out->v_sat && (out->value != out->cal_value())) {
            score -= out->unsat_cost;
        }
        if(!out->v_sat && (out->value == out->cal_value())) {
            score += out->unsat_cost;
        }
    }

    value ^= 1;
}