#include "simulator.h"

using namespace atpg_ls;

// int Simulator::verify(Circuit *circuit, int** fault_detected) {

//     // lut_circuit->check();

//     // for(LUT* lut : lut_circuit->PIs) {
//     //     printf("PI: %s = %d\n", lut->name, lut->value);
//     // }

//     int score;
//     simulate(circuit->PIs, score, fault_detected);

//     for(Gate* gate : circuit->gates) {
//         assert(gate->value == gate->cal_value());
//     }

//     std::unordered_map<int, Gate*> id2gate;
//     for(Gate* gate : gates) {
//         id2gate[gate->id] = gate;
//     }

//     return 1;
// }

void Simulator::simulate(std::vector<Gate*> &inputs, int &score, std::set<Fault> &unknown_faults) {

    assert(inputs.size() == this->PIs.size());

    for(int i=0; i<inputs.size(); i++) {
        PIs[i]->value = inputs[i]->value;
    }

    for(auto gate : gates) {
        gate->value = gate->cal_value();
    }

    for(auto gate : rtopo_gates) {
        gate->fault_detected[0] = gate->cal_fault_detected(0);
        gate->fault_detected[1] = gate->cal_fault_detected(1);
        gate->fault_propagated_len[0] = gate->cal_propagate_len(0);
        gate->fault_propagated_len[1] = gate->cal_propagate_len(1);
    }

    score = 0;

    for(auto gate : gates) {
        if(gate->fault_detected[0] && unknown_faults.count(Fault{gate->ori_gate, 0})) {
            score++;
        }
        if(gate->fault_detected[1] && unknown_faults.count(Fault{gate->ori_gate, 1})) {
            score++;
        }
    }
}